//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

//#include "dos.h"
//#include "time.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
//#pragma link "CSPIN"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
TLabel * ColorSelectLabel[24];
TLabel * ColorLabel;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   Latest = false;
   left = 160; right = 752; top = 10; bottom = 516;
   DirectoryListBox1->Directory = "C:\\windows\\desktop";
   for(int i=0; i<24; i++)
   {
      ColorLabel = new TLabel(Form1);
      ColorLabel->Parent = ColorPanel;
      ColorLabel->AutoSize = false;
      ColorLabel->Top = 2+17 * (int) (i/6);
      ColorLabel->Left = 2 + 17 * (i % 6);
      ColorLabel->Width = 16;
      ColorLabel->Height = 16;
      ColorLabel->Color = clBlack;
      ColorLabel->Alignment = taCenter;
      ColorLabel->Caption = IntToStr(i);
      colorint = (int) ColorLabel->Color;
      ColorLabel->Font->Color = (0xff - colorint & 0xFF) + (0xFF00 - colorint & 0xFF00) +
         (0xFF0000 - colorint & 0xFF0000);
      ColorLabel->OnMouseDown = ColorSelectMouseDown;
      ColorSelectLabel[i] = ColorLabel;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawButtonClick(TObject *Sender)
{
   int i, j, k, l, m;
   TColor drawcolor;
   int boxstart, colorstart;
   int modulus, range;
   float boxtop, boxbottom, boxleft, boxright, boxheight, boxwidth,
   			oldboxright, oldboxbottom, upcreep, upcreepj;
   int dummy;
   int entry[10000], tempentry[10000], grid[10000];

   Latest = true;

   k = kspinedit->Value;
   l = lspinedit->Value;
   m = mspinedit->Value;

   for(i=0; i<24; i++)
   {
      ColorSelectLabel[i]->Show();
   }
   Form1->Refresh();
   Form1->Canvas->Brush->Color = clWhite;
   Form1->Canvas->FillRect(Rect(left, top, right, bottom+2));
   modulus = ModSpinEdit->Value;
   range = RangeSpinEdit->Value;
   boxheight = (bottom - top) / (range + 1);
   //if(boxheight < 2) boxheight = 2;
   boxwidth = (right - left) / (range + 1);
   //if(boxwidth < 2) boxwidth = 2;
   boxstart = (left + right - boxwidth) / 2;

   oldboxright = 100000;

   for(i=0; i < 24; i++)
   {
      colors[i] = ColorSelectLabel[i]->Color;
   }
   if(ShuffleCheckBox->Checked == true)     //here we determine if we should
      colorstart = 0;                       //reselect all the colors each time
   else                             		//we redraw the triangle
      colorstart = 24;
   for(i=colorstart; i < modulus; i++)
   {
      colors[i] = 0x10000 * random(256) + 0x100 * random(256) + random(256);
      if(i < 24)
         ColorSelectLabel[i]->Color = colors[i];
   }
   if(Color0CheckBox->Checked == true)      //If the user wants color 0 to always
   {                                        //be black, we set it accordingly
      colors[0] = clBlack;
      ColorSelectLabel[0]->Color = clBlack;
      ColorSelectLabel[0]->Font->Color = clWhite;
   }
   for(i = 0; i < range+1 ; i++)
   {
      entry[i] = 0;
   }
   entry[0] = 1;
   upcreep = 4;
   boxleft = boxstart-boxwidth*0/2 + 0 * boxwidth;
   boxright = boxleft + boxwidth;
   if(boxwidth < 2) boxright = boxleft + 2;
   boxtop = top + 0 * boxheight;
   boxbottom = boxtop + boxheight;
   oldboxbottom = 1000000;
   Form1->Canvas->Brush->Color = colors[1];
   Form1->Canvas->FillRect(Rect(boxleft, boxtop, boxright, boxbottom));
   for(i = 1; i < range ; i++)
   {
      Application->ProcessMessages();
      if(Latest == false) break;
      boxtop = top + i * boxheight;
      boxbottom = boxtop + boxheight;
      if(boxheight < 2) boxbottom = boxtop + 2;
      if(boxtop > oldboxbottom) boxtop = oldboxbottom;
      oldboxbottom = boxbottom;

      if(LockOnesCheckBox->Checked == true)
         tempentry[0] = 1;
      else tempentry[0] = (m + entry[0] * l) % modulus;
      //tempentry[0] = 1;
      for(j = 1; j <= i ; j++)
      {
         tempentry[j] = (entry[j]*l + entry[j-1]*k + m) % modulus;
      }
      for(j = 0; j <= i ; j++)
      {
         entry[j] = tempentry[j];
      }

      if(upcreep >= 1)
      {
        //Here we make the grid to draw our boxes
        if(boxwidth < 1)
           for(j=0; j<(right-left)*i/range + 3; j++)
           {
              grid[j] = boxstart - i*(right-left)/(2*range) + j;
           }
        else
           for(j=0; j<i+2; j++)
           {
              grid[j] = boxstart - i*boxwidth/2 + j*boxwidth;
           }
        for(drawcolor = 0; drawcolor < modulus; drawcolor++)
        {
            /*if(Form1->Divisible->Checked == true)
            {
               if(drawcolor == 0) Form1->Canvas->Brush->Color = clBlack;
               else Form1->Canvas->Brush->Color = colors[1];
            }
            else*/
               Form1->Canvas->Brush->Color = colors[drawcolor];

            if(boxwidth > 1)
               for(j=0; j<i+1; j++)
               {
                 // for(dummy = 0; dummy<11700000; dummy++);
                   //  Form1->Canvas->Brush->Color = Form1->Canvas->Brush->Color;
                  if(Form1->Divisible->Checked == true)
                  {
                     if(drawcolor == 0 && entry[j] == 0 || drawcolor == 1 && entry[j] > 0)
                     {
                        boxleft = grid[j];
                        boxright = grid[j+1];
                        Form1->Canvas->FillRect(Rect(boxleft, boxtop, boxright, boxbottom));
                     }
                  }
                  else if(entry[j] == drawcolor)
                  {
                     boxleft = grid[j];
                     boxright = grid[j+1];
                     Form1->Canvas->FillRect(Rect(boxleft, boxtop, boxright, boxbottom));
                  }
               }
            else
               for(j=0; j<(right-left)*i/range; j++)
               {
                  //for(dummy = 0; dummy<11700000; dummy++);
                    // Form1->Canvas->Brush->Color = Form1->Canvas->Brush->Color;
                  if(Form1->Divisible->Checked == true)
                  {
                     if(drawcolor == 0 && entry[(int) (j * range / (right - left))] == 0
                        || drawcolor == 1 && entry[(int) (j * range / (right - left))] > 0)
                     {
                        boxleft = grid[j];
                        boxright = grid[j+1];
                        Form1->Canvas->FillRect(Rect(boxleft, boxtop, boxright, boxbottom));
                     }
                  }
                  else if(entry[(int) (j * range / (right - left))] == drawcolor)
                  {
                     boxleft = grid[j];
                     boxright = grid[j+1];
                     Form1->Canvas->FillRect(Rect(boxleft, boxtop, boxright, boxbottom));
                  }
               }
            if(Form1->Divisible->Checked == true && drawcolor ==1)
               drawcolor = modulus;
        }
      }
      upcreep += (float)(bottom - top)/(float)range;
   }
   Latest = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   Graphics::TBitmap * Pic = new Graphics::TBitmap;
   TDateTime * dt = new TDateTime;
   dt->Val = dt->CurrentDateTime();
   Pic->Width = right-left+1;
   Pic->Height = bottom-top+1;
   Pic->Canvas->CopyRect(Rect(1,1,right-left,bottom-top), Form1->Canvas,
   		Rect(left, top, right, bottom));
   Pic->SaveToFile(DirectoryListBox1->Directory + "\\Pas" +
   			IntToStr( 1000*(((int) dt->Val) % 100) + ((int)(dt->Val*100000)) % 1000)
            + ".bmp");
   //Pic->SaveToFile("c:\\windows\\desktop\\Pascal" + dt->TimeString() + ".bmp");
   delete Pic;
   delete dt;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ColorSelectMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
   bool IsColorChosen;

   if(Button == mbRight)
   {
      ((TLabel *) Sender)->Color = clBlack;
      ((TLabel *) Sender)->Font->Color = clWhite;
   }
   else
   {
      if(!ColorDialog1->Execute())
         return;
      ((TLabel *) Sender)->Color = ColorDialog1->Color;
      colorint = ColorDialog1->Color;
      ((TLabel *) Sender)->Font->Color = (colorint & 0xFF > 0x10 ? 0 : 0xFF) +
         (colorint & 0xFF00 > 0x1000 ? 0 : 0xFF00) +
         (colorint & 0xFF0000 > 0x100000 ? 0 : 0xFF0000);
   }
   ShuffleCheckBox->Checked = false;
   if(Sender == ColorSelectLabel[0] && Button != mbRight)
      Color0CheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShuffleButtonClick(TObject *Sender)
{
   int i;
   for(i=0; i < 24; i++)
   {
      colors[i] = 0x10000 * random(256) + 0x100 * random(256) + random(256);
      ColorSelectLabel[i]->Color = colors[i];
      colorint = colors[i];
      ColorSelectLabel[i]->Font->Color = (colorint & 0xFF > 0x10 ? 0 : 0xFF) +
         (colorint & 0xFF00 > 0x1000 ? 0 : 0xFF00) +
         (colorint & 0xFF0000 > 0x100000 ? 0 : 0xFF0000);
   }
   ShuffleCheckBox->Checked = false;
   if(Color0CheckBox->Checked == true)
   {
      colors[0] = clBlack;
      ColorSelectLabel[0]->Color = clBlack;
      ColorSelectLabel[0]->Font->Color = clWhite;
   }
}
//---------------------------------------------------------------------------
